package cz.jzitnik.chronos.interactions;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import cz.jzitnik.chronos.entities.Player;
import cz.jzitnik.chronos.entities.Character;
import cz.jzitnik.chronos.payload.responses.InteractionResponse;

import java.lang.reflect.ParameterizedType;

public abstract class InteractionPlayer<T> {
    private final ObjectMapper objectMapper = new ObjectMapper();
    private final TypeReference<T> typeReference;

    // I hate my life, like wtf is this shit Java. Why I cant just pass T to the objectMapper.readValue
    protected InteractionPlayer() {
        // Automatically resolve the generic type `T` using reflection
        this.typeReference = new TypeReference<>() {
            @Override
            public java.lang.reflect.Type getType() {
                return ((ParameterizedType) InteractionPlayer.this.getClass()
                        .getGenericSuperclass())
                        .getActualTypeArguments()[0];
            }
        };
    }

    public T readMemory(String memory) {
        try {
            return objectMapper.readValue(memory, typeReference);
        } catch (Exception e) {
            throw new RuntimeException("Failed to deserialize memory string into object", e);
        }
    }

    public String writeMemory(T memory) {
        try {
            return objectMapper.writeValueAsString(memory);
        } catch (JsonProcessingException e) {
            throw new RuntimeException("Failed to serialize object to memory string", e);
        }
    }

    public abstract InteractionResponse play(Player player, Character character, String data);
}
