package cz.jzitnik.chronos.services;

import cz.jzitnik.chronos.entities.*;
import cz.jzitnik.chronos.entities.Character;
import cz.jzitnik.chronos.interactions.Interaction;
import org.springframework.stereotype.Service;

import java.util.ArrayList;

@Service
public class InitGameService {
    public Room initGame(Game game) {
        var rooms = new ArrayList<Room>();

        // Outside
        var outside = new Room(
                "Outside", // Náměstí
                game
        );
        var outside_characters = new ArrayList<Character>();
        var elf_items = new ArrayList<Item>();
        var elf = new Character(
                "Skřítek",
                outside,
                "Ahoj, vím že se teď asi ptáš co tu děláš a tak dále a tak dále, ale teď na to není prostor. "
                        + "Zastavil se tu totiž čas a já potřebuji abys mi pomohl ho dát zpět do pochodu. "
                        + "Musíš najít 5 fragmentů klíče a přinést je zpět na náměstí, kde je vhodíš do brány času, a vše znovu obživne. "
                        + "Čeká tě spousta úkolů které musíš splnit na to aby jsi dostal/a fragmenty klíče. "
                        + "Taky ode mě dostaneš lektvar štěstí který ti pomůže u farmáře. "
                        + "Ale nezapomeň, v batohu můžeš nést maximálně jen tři věci. "
                        + "No nic, jdi udělat to co máš. Hodně štěstí!"
        );
        elf_items.add(new Item(ItemType.LUCK_POTION, elf));
        elf.setInventory(elf_items);
        outside_characters.add(elf);
        outside.setCharacters(outside_characters);

        // Stodola
        var stodola = new Room(
                "Stodola",
                game
        );
        var stodola_characters = new ArrayList<Character>();
        var farmar = new Character(
                "Farmář",
                stodola,
                "Ahoj! Určitě už víš co se stalo, zastavil se čas a skřítek ho potřebuje znovu obnovit. "
                        + "Ale mně se to takhle líbí, proto ti fragment klíče nedám jen tak zadarmo. "
                        + "Musíš si semnou zahrát kámen, nůžky papír. Pokud vyhraješ, dám ti fragment klíče. "
                        + "Pokud ne, tak ti fragment klíče už nikdy nedám. Hodně štěstí, budeš ho potřebovat."
        );
        farmar.setInteraction(Interaction.Farmer);
        farmar.setInteractionData(new cz.jzitnik.chronos.entities.Interaction(
                "",
                "Už si semnou zahrát nemůžeš, někdo tu byl před tebou a dostal ode mě fragment klíče.",
                farmar
        ));
        stodola_characters.add(farmar);
        stodola.setCharacters(stodola_characters);

        // Shop
        var shop = new Room(
                "Obchod",
                game
        );
        var shop_characters = new ArrayList<Character>();
        var cashier = new Character(
                "Prodavač",
                shop,
                "Dobrý den přejete si něco? Ne? Co teda chcete? Joo fragment klíče. To ale nepůjde jen tak snadno. "
                        + "Nejdřív si se mnou musíš zahrát šibenici, jestli vyhraješ tak ti samozřejmě dám fragment klíče ale pokud ne... "
                        + "tak tě na tu šibenici pověsím! Ne dělám si srandu. Pojď si zahrát."
        );
        cashier.setInteraction(Interaction.Cashier);
        cashier.setInteractionData(new cz.jzitnik.chronos.entities.Interaction(
                "",
                "Už si semnou zahrát nemůžeš, někdo tu byl před tebou a dostal ode mě fragment klíče.",
                cashier
        ));
        shop_characters.add(cashier);
        shop.setCharacters(shop_characters);

        // Knihovna
        var library = new Room(
                "Knihovna",
                game
        );
        var library_characters = new ArrayList<Character>();
        var librarian = new Character(
                "Knihovnice",
                library,
                "Ahoj, jdeš si vypujčit nějakou knihu? Jakto že ne? Učení je důležité. No to je jedno, co teda chceš? Fragment klíče? " +
                        "Budes si muset semnou zahrát nejdříve wordle na to abych ti ho dala."
        );
        librarian.setInteraction(Interaction.Librarian);
        librarian.setInteractionData(new cz.jzitnik.chronos.entities.Interaction(
                "",
                "Už si semnou zahrát nemůžeš, někdo tu byl před tebou a dostal ode mě fragment klíče.",
                librarian
        ));
        library_characters.add(librarian);
        library.setCharacters(library_characters);

        // Hospoda
        var inn = new Room(
                "Hospoda",
                game
        );
        var inn_characters = new ArrayList<Character>();
        var innkeeper = new Character(
                "Hostinský",
                inn,
                "No nazdar! Jak pak se máš člověče. Doufám že dobre, tady je to celkem mizerné, Nechceš  mi zvednout náladu a zahrát si semnou piškvorky? Dam ti za to i fragment klíče který tak moc hledáš."
        );
        innkeeper.setInteraction(Interaction.Innkeeper);
        innkeeper.setInteractionData(new cz.jzitnik.chronos.entities.Interaction(
                "",
                "Už si semnou zahrát nemůžeš, někdo tu byl před tebou a dostal ode mě fragment klíče.",
                innkeeper
        ));
        inn_characters.add(innkeeper);
        inn.setCharacters(inn_characters);

        // Dům starosty
        var mayor_house = new Room(
                "Dům starosty",
                game
        );
        var mayor_house_characters = new ArrayList<Character>();
        // Never gonna give you up - If you are reading this then I hope you have a great day :)
        var mayor = new Character(
                "Starosta",
                mayor_house,
                "Dobrý den, nechci Vás nějak moc otravovat, ale potřebuji pomoc. Někde jsem ztratil své zlaté hodinky ale nevzpomínám si kde. Pomůžete mi je najít prosím?"
        );
        mayor.setInteraction(Interaction.Mayor);
        mayor.setInteractionData(new cz.jzitnik.chronos.entities.Interaction(
                "",
                "Děkuji ale zlaté hodinky už mi někdo navrátil. Děkuji za pomoc.",
                mayor
        ));
        mayor_house_characters.add(mayor);
        mayor_house.setCharacters(mayor_house_characters);

        // Zarostlá zahrada
        var garden = new Room(
                "Zarostlá zahrada",
                game
        );
        // Zlaté hodinky pro starostu
        garden.getItems().add(new Item(ItemType.GOLDEN_WATCH, garden));

        // Kovárna
        var forge = new Room(
                "Kovárna",
                game
        );
        var forge_characters = new ArrayList<Character>();
        var blacksmith = new Character(
                "Kovář",
                forge,
                "Ahoj, co tu pohledáváš? Ne, nic mi neříkej, moc mě to nezajímá. Potřebuju ale pomoct. Najdi prosím nějaké uhlí a přines mi ho. Můžeme si potom zahrát \"Number Guessing Game\" a pokud vyhraješ dám ti i fragment klíče."
        );
        blacksmith.setInteraction(Interaction.Blacksmith);
        blacksmith.setInteractionData(new cz.jzitnik.chronos.entities.Interaction(
                "",
                "Děkuji ale uhlí už mi někdo dal. Děkuji za pomoc.",
                mayor
        ));
        forge_characters.add(blacksmith);
        forge.setCharacters(forge_characters);

        // Sklad
        var warehouse = new Room(
                "Sklad",
                game
        );
        warehouse.getItems().add(new Item(ItemType.COAL, warehouse));
        warehouse.getItems().add(new Item(ItemType.WATER, warehouse));
        warehouse.getItems().add(new Item(ItemType.FLOUR, warehouse));

        // Pekárna
        var bakery = new Room(
                "Pekárna",
                game
        );
        var bakery_characters = new ArrayList<Character>();
        var baker = new Character(
                "Pekařka",
                bakery,
                "Ahoj, pomůžeš mi prosím? Potřebuju na zítra upéct chleba ale nikde nemůžu sehnat mouku a vodu. Zašel/la by jsi pro ně prosím? Jako odměnu ti dám fragment klíče."
        );
        baker.setInteraction(Interaction.Baker);
        baker.setInteractionData(new cz.jzitnik.chronos.entities.Interaction(
                "",
                "Mouku a vodu už mám. Děkuji za pomoc.",
                baker
        ));
        bakery_characters.add(baker);
        bakery.setCharacters(bakery_characters);


        rooms.add(outside);
        rooms.add(stodola);
        rooms.add(shop);
        rooms.add(library);
        rooms.add(inn);
        rooms.add(mayor_house);
        rooms.add(garden);
        rooms.add(forge);
        rooms.add(warehouse);
        rooms.add(bakery);

        game.setRooms(rooms);

        game.setWonMessage("Moc ti děkuji za pomoc, čas už zase běží jak má a všichni jsou spokojeni. Jako velké poděkování ti sem postavíme tvoji sochu. Za zase někdy přijdi!");

        // Return a room that all players will spawn in
        return outside;
    }
}