package cz.jzitnik.game.interactions.list;

import cz.jzitnik.api.ApiService;
import cz.jzitnik.api.requests.InteractionRequest;
import cz.jzitnik.api.types.Character;
import cz.jzitnik.api.types.ItemType;
import cz.jzitnik.utils.Cli;
import lombok.AllArgsConstructor;

import java.io.IOException;
import java.util.Arrays;


@AllArgsConstructor
public class Baker {
    private Character character;
    private ApiService apiService;
    private String playerKey;

    public void play() throws IOException {
        var response = apiService.getMe(playerKey).execute();
        var me = response.body().getData().get();

        var hasWater = me.getInventory().stream().anyMatch(item -> item.getItemType().equals(ItemType.WATER));
        var hasFlour = me.getInventory().stream().anyMatch(item -> item.getItemType().equals(ItemType.FLOUR));

        if (!hasWater || !hasFlour) {
            // Player does not have water or flour
            return;
        }

        var options = new String[]{"Dát pekařce vodu a mouku", "Nedat pekařce vodu a mouku"};
        var selected = Cli.selectOptionIndex(Arrays.stream(options).toList());

        if (selected == 0) {
            var res = apiService.interact(playerKey, new InteractionRequest("", character.getId())).execute();
            var data = res.body().getData().get();

            Cli.type(character, data.getResponseText());
            Cli.gotItems(data.getItems());
        }
    }
}
