package cz.jzitnik.game.interactions.list;

import cz.jzitnik.api.ApiService;
import cz.jzitnik.api.requests.InteractionRequest;
import cz.jzitnik.api.types.Character;
import cz.jzitnik.utils.Cli;
import lombok.AllArgsConstructor;

import java.io.IOException;
import java.util.Arrays;


@AllArgsConstructor
public class RockPaperScissors {
    private Character character;
    private ApiService apiService;
    private String playerKey;

    public void play() throws IOException {
        var options = new String[]{"Kámen", "Nůžky", "Papír"};
        var selected = Cli.selectOptionIndex(Arrays.stream(options).toList());

        var requestData = new InteractionRequest(String.valueOf(selected), character.getId());

        var res = apiService.interact(playerKey, requestData).execute();
        var interactionResponse = res.body().getData().get();

        Cli.type(character, interactionResponse.getResponseText());

        if (interactionResponse.isSuccess()) {
            Cli.gotItems(interactionResponse.getItems());
        }
    }
}
